' Useless machine / expert servo
' Aenderungen gegenber Weidmann-Originalsoftware:
' Servo verlangsamt (faehrt Rampe ab)
' Pulse mit "Pulseout" erzeugt (bei kurzen Zeiten genauer als Wait)
' Konstanten Servo_min und Servo_max definiert
' Da noch Platz im Flash war, "rumpelt" die Maschine erst zwei Mal,
' klappert dann drei mal mit dem Deckel und schaltet dann erst den Kippschalter
' Danach "grummelt" sie noch mal 

' Compiler: BASCOM 2.0.7.5 Demo


$regfile = "Attiny13.dat"                                   ' specify the used micro
$crystal = 1200000                                          ' used crystal frequency
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 8                                               ' default use 10 for the SW stack
$framesize = 8                                             ' default use 40 for the frame space


Config Portb.2 = Output                                     'Servo Signal
Config Portb.4 = Output                                     'Servo AN/AUS

Portb.2 = 0                                                 'PIN initialisieren (OFF)
Portb.4 = 0                                                 'PIN initialisieren (OFF)
Portb.1 = 1                                                 'Internen Pullup EIN
Didr0 = &B00011101                                          'ungenutzte Digitaleingaenge stillegen

Config Int0 = Low Level                                     'Int0 auf Low Level konfigurieren
Enable Interrupts                                           'Einschalten der Interrupts
Enable Int0                                                 'Einschalten Von Interrupt Int0

Dim I As Word
Dim K as Word

Const Servo_min = 200                                       ' Servo-Ruhestellung
Const Servo_max = 540                                       ' Max. Servo-Auslenkung
Const Servo_rumble = 220                                    ' Servobewegung ohne Heben des Deckels
Const Servo_knock = 260                                     ' Servobewegung mit Heben des Deckels





Do
   Disable Int0                                             'Ausschalten Von Interrupt Int0

   If Pinb.1 = 0 Then                                       'Prfen ob Kippschalter ON ist
      Wait 1                                                '1 Sek warten
      If Pinb.1 = 0 Then                                    'Prfen ob Kippschalter ON ist
         Portb.4 = 1                                        'Servo VCC ber Relais einschalten

         For K = 1 To 2                                     ' zwei Mal Rumpeln ohne Heben des Deckels 
            For I = 1 to 10
               Pulseout Portb, 2, Servo_rumble
               Waitms 15
            Next
            For I = 1 to 10
               Pulseout Portb, 2, Servo_min
               Waitms 15
            Next
         Next
         Wait 1                                            '1 Sek warten

         For K = 1 To 3                                    ' drei Mal Rumpeln mit Heben des Deckels 
            For I = 1 to 10
               Pulseout Portb, 2, Servo_knock
               Waitms 15
            Next
            For I = 1 to 10
               Pulseout Portb, 2, Servo_min
               Waitms 15
            Next
         Next
         Wait 1                                            '1 Sek warten


         For I = Servo_min to Servo_max Step 5
            Pulseout Portb, 2, I
            Waitms 20
            If Pinb.1 = 1 Then                              'Prfen ob Kippschalter OFF ist und
               I = I + 10                                    'Sicher gehen, dass der Kippschalter nicht halb-aus ist
               Pulseout Portb, 2, I                         'Sicher gehen, dass der Kippschalter nicht halb-aus ist
              Exit For                                      'Schleife Verlassen
            End If
         Next

         For K = I to Servo_min Step -5                     'Arm hineinfahren
            Pulseout Portb, 2, K
            Waitms 20
         Next

         Wait 1

         For I = 1 to 10                                    ' noch mal grummeln
            Pulseout Portb, 2, Servo_rumble
            Waitms 20
         Next
         For I = 1 to 10
            Pulseout Portb, 2, Servo_min
            Waitms 25
         Next

         Portb.4 = 0                                        'Servo VCC ber Relais ausschalten
      End If
   End If


   If Pinb.1 = 1 Then                                       'Prfen ob Kippschalter OFF ist
      Enable Int0                                           'Einschalten Von Interrupt Int0
      Powerdown                                             'Controller einschlafen lassen
   End If
Loop


End
